     /*  Validyne MFC113 Card Interface   
	This program reads a value from channel 0
	of an MFC113 A/D card at I/O address 380h (896d) */

# include <asm/io.h>         
main()
{
	float FS, Reading;          /* Dim FP variables  */
	int Hi, Lo, Gain, Channel;  /* Dim int variables */
	long int Delay, Count;      /* Dim long int  */
	char x;			    /* Keybd input  */

	
	Gain = 0;		/* Set to +/-5 V range          */
	FS = 5.00;		/* Set Full Scale for Gain 0    
	
				   Gain - FS Relationship     
				   Gain = 0  : FS =  5.00     
				   Gain = 8  : FS = 10.00     
				   Gain = 10 : FS =  1.00     
				   Gain = 12 : FS =  0.50     
				   Gain = 14 : FS =  0.01     */ 


	Channel = 0;		/* Set to Ch 0  */
	Delay = 1000;		/* Set Delay	*/
	Lo = 0;			/* Initialize Lo byte  */
	Hi = 0;			/* Initialize Hi byte  */
	Reading = 0.00;		/* Initialize Reading  */
	x = 'y';		/* Initialize keyboard exit detect  */


	ioperm(0x380,8,1);	/* Enable I/O Port access  */

	while (x != 'x')        /* Test for keybd input    */
	{
	  
	  outb(Gain,0x383);	/* Set MFC Gain  */

	  Count = 0;
	  while (Count < Delay) /* Loop Delay    */
	  Count++;

	  outb(Channel, 0x382);	/* Set MFC Channel  */
	  Count = 0;
	  while(Count < Delay)   /* Loop Delay  */
	  Count++;

	  outb(1, 0x381);     	     /* Start A/D conversion */
	  Count = 0;		     /* Initialize Delay  */
	  while (Count < Delay)      /*  Delay Loop  */
	  Count ++;

	  Lo = inb(0x380);		/* Get Low Byte  */ 	
	  Count = 0;
	  while(Count < Delay)
	  Count++;

	  Hi = inb(0x381);		/* Get Hi Byte  */
	  Count = 0;
	  while(Count < Delay)
	  Count++;

	  Reading = FS * (((Hi*16)+(Lo/16))-2047)/2048;
	
	  printf("Reading = %.2f ", Reading);     /* Print Reading  */

	x = getchar();	
	}

	printf("Ending... \n");
}



